var div_cr,div_prv_m,div_prv_y,div_nxt_m,div_nxt_y;
var arr_holiday = new Array();
var cr_year,cr_month,cr_day
var disp_year,disp_month,disp_day
var styleSheets;
var vpf=new Array("","-moz-","-webkit-","-o-","-ms-")
function init() {
  var today=new Date();
  cr_year=today.getFullYear();
  cr_month=today.getMonth();
  cr_day=today.getDate();
  div_calendar=document.getElementById("ls_calendar");
  div_cr=document.getElementById("cal_current");
  div_disp=document.getElementById("cal_display");
  div_prev_y=document.getElementById("cal_prev_y");
  div_prev_m=document.getElementById("cal_prev_m");
  div_next_m=document.getElementById("cal_next_m");
  div_next_y=document.getElementById("cal_next_y");
  
  var url="http://ical.mac.com/ical/Japanese32Holidays.ics";
	var httpRequest = new XMLHttpRequest();
	httpRequest.open("GET", url);
	httpRequest.overrideMimeType("text/calendar");
  httpRequest.setRequestHeader('Cache-Control', 'no-cache');
	httpRequest.send(null);
	httpRequest.onload = function() {xml_responded(httpRequest);}

}
function xml_responded (request) {
  var resData = request.responseText;
  var split_Data = resData.split("UID");
  for (var i=1; i < split_Data.length; i++) {
    data_index = split_Data[i].substring(split_Data[i].indexOf("DATE")+5,split_Data[i].indexOf("DTEND")-1);
    data_value = split_Data[i].substring(split_Data[i].indexOf("SUMMARY")+8,split_Data[i].indexOf("RESOURCES")-1);
    arr_holiday[data_index] = data_value;
  }
  disp_year=cr_year;
  disp_month=cr_month;
  disp_day=cr_day;
  styleSheets = document.styleSheets[0];
//  var ss = styleSheets[0];
  display_calendar(disp_year,disp_month,disp_day);
}

function display_calendar(year,month,day) {
	div_cr.innerHTML = make_calendar(cr_year,cr_month,cr_day);//現在_カレンダー
	div_disp.innerHTML = make_calendar(year,month,day);//表示用_カレンダー
  div_calendar.className = "transition_off";
	div_prev_y.innerHTML = make_calendar(year-1,month,day);//前年_カレンダー
	div_prev_m.innerHTML = make_calendar(year-(month==0),(month+11)%12,day);//前月_カレンダー
	div_next_m.innerHTML = make_calendar(year+(month==11),(month+1)%12,day);//翌月_カレンダー
	div_next_y.innerHTML = make_calendar(year+1,month,day);//翌年_カレンダー
  document.getElementById("btn_current").onclick = new Function("display_calendar("+cr_year+","+cr_month+","+cr_day+")");//現在_ボタン
  document.getElementById("btn_prev_y").onclick = new Function("transition_calendar("+(year-1)+","+month+","+day+",1,0,600)");//前年_ボタン
  document.getElementById("btn_prev_m").onclick = new Function("transition_calendar("+(year-(month==0))+","+(month+11)%12+","+day+",1,640,0)");//前月_ボタン
  document.getElementById("btn_next_m").onclick = new Function("transition_calendar("+(year+(month==11))+","+(month+1)%12+","+day+",1,-640,0)");//翌月_ボタン
  document.getElementById("btn_next_y").onclick = new Function("transition_calendar("+(year+1)+","+month+","+day+",1,0,-600)");//翌年_ボタン
  document.getElementById("buttons").className = "on";
}

function transition_calendar(year,month,day,transitions,x,y) {
  var str;
  for( i=0; i<vpf.length; i++) {
    if( transitions==1) {
    	str = vpf[i] + "transform: "+"translate("+x+"px, "+y+"px);";
  		styleSheets.addRule("#ls_calendar.transition_on", str );
    	str = vpf[i] + "transition: "+vpf[i] + "transform 0.3s ease-out 0;";
  		styleSheets.addRule("#ls_calendar.transition_on", str );
//    	str = "opacity: 1;";
//  		styleSheets.addRule("#ls_calendar.transition_on", str );
//    	str = vpf[i] + "transition: opacity 0.2s ease-out 0;";
//  		styleSheets.addRule("#ls_calendar.transition_on", str );
    }
  }

  div_calendar.className = "transition_on"
  disp_year=year;
  disp_month=month;
  disp_day=day;
  div_calendar.addEventListener(
      'webkitTransitionEnd',
      transition_end_calendar,
      false
      );
  document.getElementById("buttons").className = "off";
}
function transition_end_calendar() {
  div_calendar.removeEventListener(
      'webkitTransitionEnd',
      transition_end_calendar,
      false
      );
  for( i=0; i<vpf.length; i++) {
    styleSheets.deleteRule(styleSheets.cssRules.length -1 );
    styleSheets.deleteRule(styleSheets.cssRules.length -1 );
//    styleSheets.deleteRule(styleSheets.cssRules.length -1 );
  }

  display_calendar(disp_year,disp_month,disp_day);
}

function make_calendar(year,month,day) {
  var leap_year=((year%4 == 0 && year%100 != 0) || (year%400 == 0));
  ary_month=new Array(31,28+leap_year,31,30,31,30,31,31,30,31,30,31);
  ary_day=new Array("日","月","火","水","木","金","土");
  var days=0;
  for (var i=0; i < month; i++){
		days+=ary_month[i];
  }
  var week=Math.floor((year*365.2425+days)%7);
  var j=1;
  var k;
  var calendar="<table>\n";
  calendar+='<tr><td class="td_caption" colspan="7">';
//  calendar+='<p id="btn_prv_prv" class="button">←<br>←</p>';
//  calendar+='<p id="btn_prv" onClick="display_calendar(year,month-1,day)">←前月へ</p>';
//  calendar+='<input id="btn_prv" class="button" value="←前月" onclick="display_calendar("+year+","+(month-1)+","+day+")"/>';
  calendar+='<p id="p_caption">' +year+"年 "+(month+1)+"月" + "</p>";
//  calendar+='<p id="btn_nxt" class="button">→</p>';
//  calendar+='<p id="btn_nxt_nxt" class="button">→<br>→</p>';
  calendar+= "</td></tr>\n";
  calendar+="<tr>";
  for (i=1; i <= 7; i++){
		calendar+='<td class="day ';
		if (i%7 == 0){
	    calendar+=' sun';
		}
		if (i == 6){
	    calendar+=' sat';
		}
		calendar+='">'+ary_day[i%7]+"</td>";
  }
  calendar+="</tr>\n<tr>";
  for (i=0; i < (week+6)%7; i++){
		k=ary_month[(month+11)%12]-(week+6)%7+i+1;
		calendar+='<td class="blank">' + k + '</td>';
		j++;
  }
  for (i=1; i <= ary_month[month]; i++) {
		holiday = arr_holiday[year*10000+month*100+100+i];
		calendar+="<td";
		if (year == cr_year && month == cr_month && day == i && 0 < day){
	    calendar+=' id="today"';
		}
		if (typeof holiday != "undefined"){
	    calendar+=' class="sun"';
		}
		else if (j == 7){
	    calendar+=' class="sun"';
		}
		else if (j == 6){
	    calendar+=' class="sat"';
		}
		calendar+=">"+i;
		if (typeof holiday != "undefined"){
		calendar+='<p class="';
		if (holiday.length == 5){
		  calendar+="holiday5";
		}
		else if (holiday.length == 6){
		  calendar+="holiday6";
		}
		else {
		  calendar+="holiday";
		}
		calendar+='">' + holiday + '</p>';
		}
		calendar+="</td>";
		j++;
		if (j > 7) {
	    calendar+="</tr>\n<tr>";
	    j=1;
		}
  }
  k=1;
  j= j==1 ? 8:j;
  for (i=j; i <= 7; i++){
		calendar+='<td class="blank">' + k + '</td>';
		k++;
  }
  calendar+="</tr>\n</table>\n";
  return calendar;
}
